[API Reference](../README.md) > [UpgradeSchemeWrapper](../classes/UpgradeSchemeWrapper.md)



# Class: UpgradeSchemeWrapper

## Hierarchy


↳  [ProposalGeneratorBase](ProposalGeneratorBase.md)

**↳ UpgradeSchemeWrapper**







## Implements

* [IContractWrapperBase](../interfaces/IContractWrapperBase.md)
* [SchemeWrapper](../interfaces/SchemeWrapper.md)

## Index

### Constructors

* [constructor](UpgradeSchemeWrapper.md#constructor)


### Properties

* [ChangeUpgradeSchemeProposal](UpgradeSchemeWrapper.md#ChangeUpgradeSchemeProposal)
* [NewUpgradeProposal](UpgradeSchemeWrapper.md#NewUpgradeProposal)
* [ProposalDeleted](UpgradeSchemeWrapper.md#ProposalDeleted)
* [ProposalExecuted](UpgradeSchemeWrapper.md#ProposalExecuted)
* [contract](UpgradeSchemeWrapper.md#contract)
* [factory](UpgradeSchemeWrapper.md#factory)
* [friendlyName](UpgradeSchemeWrapper.md#friendlyName)
* [name](UpgradeSchemeWrapper.md#name)


### Accessors

* [address](UpgradeSchemeWrapper.md#address)


### Methods

* [estimateGas](UpgradeSchemeWrapper.md#estimateGas)
* [getController](UpgradeSchemeWrapper.md#getController)
* [getDefaultPermissions](UpgradeSchemeWrapper.md#getDefaultPermissions)
* [getExecutedProposals](UpgradeSchemeWrapper.md#getExecutedProposals)
* [getParameters](UpgradeSchemeWrapper.md#getParameters)
* [getParametersArray](UpgradeSchemeWrapper.md#getParametersArray)
* [getParametersHash](UpgradeSchemeWrapper.md#getParametersHash)
* [getSchemeParameters](UpgradeSchemeWrapper.md#getSchemeParameters)
* [getSchemeParametersHash](UpgradeSchemeWrapper.md#getSchemeParametersHash)
* [getSchemePermissions](UpgradeSchemeWrapper.md#getSchemePermissions)
* [getVotableProposal](UpgradeSchemeWrapper.md#getVotableProposal)
* [getVotableUpgradeControllerProposals](UpgradeSchemeWrapper.md#getVotableUpgradeControllerProposals)
* [getVotableUpgradeUpgradeSchemeProposals](UpgradeSchemeWrapper.md#getVotableUpgradeUpgradeSchemeProposals)
* [getVotingMachine](UpgradeSchemeWrapper.md#getVotingMachine)
* [getVotingMachineAddress](UpgradeSchemeWrapper.md#getVotingMachineAddress)
* [hydrateFromAt](UpgradeSchemeWrapper.md#hydrateFromAt)
* [hydrateFromDeployed](UpgradeSchemeWrapper.md#hydrateFromDeployed)
* [hydrateFromNew](UpgradeSchemeWrapper.md#hydrateFromNew)
* [proposeController](UpgradeSchemeWrapper.md#proposeController)
* [proposeUpgradingScheme](UpgradeSchemeWrapper.md#proposeUpgradingScheme)
* [setParameters](UpgradeSchemeWrapper.md#setParameters)



---
## Constructors
<a id="constructor"></a>


### ⊕ **new UpgradeSchemeWrapper**(solidityContract: *`any`*, web3EventService: *[Web3EventService](Web3EventService.md)*): [UpgradeSchemeWrapper](UpgradeSchemeWrapper.md)


*Inherited from [ProposalGeneratorBase](ProposalGeneratorBase.md).[constructor](ProposalGeneratorBase.md#constructor)*

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[constructor](ContractWrapperBase.md#constructor)*

*Defined in [proposalGeneratorBase.ts:10](https://github.com/daostack/arc.js/blob/9063ecdf/lib/proposalGeneratorBase.ts#L10)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| solidityContract | `any`   |  - |
| web3EventService | [Web3EventService](Web3EventService.md)   |  - |





**Returns:** [UpgradeSchemeWrapper](UpgradeSchemeWrapper.md)

---


## Properties
<a id="ChangeUpgradeSchemeProposal"></a>

###  ChangeUpgradeSchemeProposal

**●  ChangeUpgradeSchemeProposal**:  *[EventFetcherFactory](../#EventFetcherFactory)[ChangeUpgradeSchemeProposalEventResult](../interfaces/ChangeUpgradeSchemeProposalEventResult.md)* 

*Defined in [wrappers/upgradeScheme.ts:32](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L32)*





___

<a id="NewUpgradeProposal"></a>

###  NewUpgradeProposal

**●  NewUpgradeProposal**:  *[EventFetcherFactory](../#EventFetcherFactory)[NewUpgradeProposalEventResult](../interfaces/NewUpgradeProposalEventResult.md)* 

*Defined in [wrappers/upgradeScheme.ts:31](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L31)*



Events




___

<a id="ProposalDeleted"></a>

###  ProposalDeleted

**●  ProposalDeleted**:  *[EventFetcherFactory](../#EventFetcherFactory)[ProposalDeletedEventResult](../interfaces/ProposalDeletedEventResult.md)* 

*Defined in [wrappers/upgradeScheme.ts:34](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L34)*





___

<a id="ProposalExecuted"></a>

###  ProposalExecuted

**●  ProposalExecuted**:  *[EventFetcherFactory](../#EventFetcherFactory)[SchemeProposalExecutedEventResult](../interfaces/SchemeProposalExecutedEventResult.md)* 

*Defined in [wrappers/upgradeScheme.ts:33](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L33)*





___

<a id="contract"></a>

###  contract

**●  contract**:  *`any`* 

*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[contract](../interfaces/IContractWrapperBase.md#contract)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[contract](ContractWrapperBase.md#contract)*

*Defined in [contractWrapperBase.ts:62](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L62)*



The underlying truffle contract object. Use this to access parts of the contract that aren't accessible via the wrapper.




___

<a id="factory"></a>

###  factory

**●  factory**:  *[IContractWrapperFactory](../interfaces/IContractWrapperFactory.md)[UpgradeSchemeWrapper](UpgradeSchemeWrapper.md)*  =  UpgradeSchemeFactory

*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[factory](../interfaces/IContractWrapperBase.md#factory)*

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[factory](ContractWrapperBase.md#factory)*

*Defined in [wrappers/upgradeScheme.ts:26](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L26)*





___

<a id="friendlyName"></a>

###  friendlyName

**●  friendlyName**:  *`string`*  = "Upgrade Scheme"

*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[friendlyName](../interfaces/IContractWrapperBase.md#friendlyName)*

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[friendlyName](ContractWrapperBase.md#friendlyName)*

*Defined in [wrappers/upgradeScheme.ts:25](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L25)*





___

<a id="name"></a>

###  name

**●  name**:  *`string`*  = "UpgradeScheme"

*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[name](../interfaces/IContractWrapperBase.md#name)*

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[name](ContractWrapperBase.md#name)*

*Defined in [wrappers/upgradeScheme.ts:24](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L24)*





___


## Accessors
<a id="address"></a>

###  address


getaddress(): [Address](../#Address)

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[address](ContractWrapperBase.md#address)*

*Defined in [contractWrapperBase.ts:57](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L57)*



The address of the contract




**Returns:** [Address](../#Address)



___


## Methods
<a id="estimateGas"></a>

###  estimateGas

► **estimateGas**(func: *[ITruffleContractFunction](../interfaces/ITruffleContractFunction.md)*, params: *`Array`.<`any`>*, web3Params?: *`any`*): `Promise`.<`number`>



*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[estimateGas](ContractWrapperBase.md#estimateGas)*

*Defined in [contractWrapperBase.ts:192](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L192)*



Estimate conservatively the amount of gas required to execute the given function with the given parameters. Adds 21000 to the estimate computed by web3.


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| func | [ITruffleContractFunction](../interfaces/ITruffleContractFunction.md)  | - |   The function |
| params | `Array`.<`any`>  | - |   The parameters to send to the function |
| web3Params | `any`  |  {} |   The web3 parameters (like "from", for example). If it contains "gas"then that value is returned, effectively a no-op. |





**Returns:** `Promise`.<`number`>





___

<a id="getController"></a>

###  getController

► **getController**(avatarAddress: *[Address](../#Address)*): `Promise`.<`any`>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[getController](../interfaces/IContractWrapperBase.md#getController)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getController](ContractWrapperBase.md#getController)*

*Defined in [contractWrapperBase.ts:178](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L178)*



Returns the controller associated with the given avatar


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<`any`>





___

<a id="getDefaultPermissions"></a>

###  getDefaultPermissions

► **getDefaultPermissions**(): [SchemePermissions](../enums/SchemePermissions.md)



*Implementation of [SchemeWrapper](../interfaces/SchemeWrapper.md).[getDefaultPermissions](../interfaces/SchemeWrapper.md#getDefaultPermissions)*

*Defined in [wrappers/upgradeScheme.ts:118](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L118)*





**Returns:** [SchemePermissions](../enums/SchemePermissions.md)





___

<a id="getExecutedProposals"></a>

###  getExecutedProposals

► **getExecutedProposals**(avatarAddress: *[Address](../#Address)*): [EntityFetcherFactory](../#EntityFetcherFactory)[SchemeProposalExecuted](../interfaces/SchemeProposalExecuted.md), [SchemeProposalExecutedEventResult](../interfaces/SchemeProposalExecutedEventResult.md)



*Defined in [wrappers/upgradeScheme.ts:183](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L183)*



EntityFetcherFactory for executed proposals.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** [EntityFetcherFactory](../#EntityFetcherFactory)[SchemeProposalExecuted](../interfaces/SchemeProposalExecuted.md), [SchemeProposalExecutedEventResult](../interfaces/SchemeProposalExecutedEventResult.md)





___

<a id="getParameters"></a>

###  getParameters

► **getParameters**(paramsHash: *[Hash](../#Hash)*): `Promise`.<[StandardSchemeParams](../interfaces/StandardSchemeParams.md)>



*Implementation of [SchemeWrapper](../interfaces/SchemeWrapper.md).[getParameters](../interfaces/SchemeWrapper.md#getParameters)*

*Overrides [ContractWrapperBase](ContractWrapperBase.md).[getParameters](ContractWrapperBase.md#getParameters)*

*Defined in [wrappers/upgradeScheme.ts:130](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L130)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| paramsHash | [Hash](../#Hash)   |  - |





**Returns:** `Promise`.<[StandardSchemeParams](../interfaces/StandardSchemeParams.md)>





___

<a id="getParametersArray"></a>

###  getParametersArray

► **getParametersArray**(paramsHash: *[Hash](../#Hash)*): `Promise`.<`Array`.<`any`>>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[getParametersArray](../interfaces/IContractWrapperBase.md#getParametersArray)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getParametersArray](ContractWrapperBase.md#getParametersArray)*

*Defined in [contractWrapperBase.ts:170](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L170)*



Given a hash, returns the associated parameters as an array, ordered by the order in which the parameters appear in the contract's Parameters struct.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| paramsHash | [Hash](../#Hash)   |  - |





**Returns:** `Promise`.<`Array`.<`any`>>





___

<a id="getParametersHash"></a>

###  getParametersHash

► **getParametersHash**(params: *[StandardSchemeParams](../interfaces/StandardSchemeParams.md)*): `Promise`.<[Hash](../#Hash)>



*Overrides [ContractWrapperBase](ContractWrapperBase.md).[getParametersHash](ContractWrapperBase.md#getParametersHash)*

*Defined in [wrappers/upgradeScheme.ts:97](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L97)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| params | [StandardSchemeParams](../interfaces/StandardSchemeParams.md)   |  - |





**Returns:** `Promise`.<[Hash](../#Hash)>





___

<a id="getSchemeParameters"></a>

###  getSchemeParameters

► **getSchemeParameters**(avatarAddress: *[Address](../#Address)*): `Promise`.<[StandardSchemeParams](../interfaces/StandardSchemeParams.md)>



*Implementation of [SchemeWrapper](../interfaces/SchemeWrapper.md).[getSchemeParameters](../interfaces/SchemeWrapper.md#getSchemeParameters)*

*Defined in [wrappers/upgradeScheme.ts:126](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L126)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[StandardSchemeParams](../interfaces/StandardSchemeParams.md)>





___

<a id="getSchemeParametersHash"></a>

###  getSchemeParametersHash

► **getSchemeParametersHash**(avatarAddress: *[Address](../#Address)*): `Promise`.<[Hash](../#Hash)>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[getSchemeParametersHash](../interfaces/IContractWrapperBase.md#getSchemeParametersHash)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[getSchemeParametersHash](ContractWrapperBase.md#getSchemeParametersHash)*

*Defined in [contractWrapperBase.ts:160](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L160)*



Given an avatar address, returns the schemes parameters hash


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[Hash](../#Hash)>





___

<a id="getSchemePermissions"></a>

###  getSchemePermissions

► **getSchemePermissions**(avatarAddress: *[Address](../#Address)*): `Promise`.<[SchemePermissions](../enums/SchemePermissions.md)>



*Implementation of [SchemeWrapper](../interfaces/SchemeWrapper.md).[getSchemePermissions](../interfaces/SchemeWrapper.md#getSchemePermissions)*

*Defined in [wrappers/upgradeScheme.ts:122](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L122)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[SchemePermissions](../enums/SchemePermissions.md)>





___

<a id="getVotableProposal"></a>

###  getVotableProposal

► **getVotableProposal**(avatarAddress: *[Address](../#Address)*, proposalId: *[Hash](../#Hash)*): `Promise`.<[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md)>



*Defined in [wrappers/upgradeScheme.ts:201](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L201)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |
| proposalId | [Hash](../#Hash)   |  - |





**Returns:** `Promise`.<[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md)>





___

<a id="getVotableUpgradeControllerProposals"></a>

###  getVotableUpgradeControllerProposals

► **getVotableUpgradeControllerProposals**(avatarAddress: *[Address](../#Address)*): `Promise`.<[EntityFetcherFactory](../#EntityFetcherFactory)[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md), [NewUpgradeProposalEventResult](../interfaces/NewUpgradeProposalEventResult.md)>



*Defined in [wrappers/upgradeScheme.ts:163](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L163)*



EntityFetcherFactory for votable UpgradeSchemeProposal.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[EntityFetcherFactory](../#EntityFetcherFactory)[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md), [NewUpgradeProposalEventResult](../interfaces/NewUpgradeProposalEventResult.md)>





___

<a id="getVotableUpgradeUpgradeSchemeProposals"></a>

###  getVotableUpgradeUpgradeSchemeProposals

► **getVotableUpgradeUpgradeSchemeProposals**(avatarAddress: *[Address](../#Address)*): `Promise`.<[EntityFetcherFactory](../#EntityFetcherFactory)[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md), [ChangeUpgradeSchemeProposalEventResult](../interfaces/ChangeUpgradeSchemeProposalEventResult.md)>



*Defined in [wrappers/upgradeScheme.ts:142](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L142)*



EntityFetcherFactory for votable UpgradeSchemeProposal.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[EntityFetcherFactory](../#EntityFetcherFactory)[VotableUpgradeSchemeProposal](../interfaces/VotableUpgradeSchemeProposal.md), [ChangeUpgradeSchemeProposalEventResult](../interfaces/ChangeUpgradeSchemeProposalEventResult.md)>





___

<a id="getVotingMachine"></a>

###  getVotingMachine

► **getVotingMachine**(avatarAddress: *[Address](../#Address)*): `Promise`.<[IntVoteInterfaceWrapper](IntVoteInterfaceWrapper.md)>



*Inherited from [ProposalGeneratorBase](ProposalGeneratorBase.md).[getVotingMachine](ProposalGeneratorBase.md#getVotingMachine)*

*Defined in [proposalGeneratorBase.ts:30](https://github.com/daostack/arc.js/blob/9063ecdf/lib/proposalGeneratorBase.ts#L30)*



Return IntVoteInterfaceWrapper for this scheme as registered with the given avatar.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[IntVoteInterfaceWrapper](IntVoteInterfaceWrapper.md)>





___

<a id="getVotingMachineAddress"></a>

###  getVotingMachineAddress

► **getVotingMachineAddress**(avatarAddress: *[Address](../#Address)*): `Promise`.<[Address](../#Address)>



*Inherited from [ProposalGeneratorBase](ProposalGeneratorBase.md).[getVotingMachineAddress](ProposalGeneratorBase.md#getVotingMachineAddress)*

*Defined in [proposalGeneratorBase.ts:22](https://github.com/daostack/arc.js/blob/9063ecdf/lib/proposalGeneratorBase.ts#L22)*



Return the address of the voting machine for this scheme as registered with the given avatar.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| avatarAddress | [Address](../#Address)   |  - |





**Returns:** `Promise`.<[Address](../#Address)>





___

<a id="hydrateFromAt"></a>

###  hydrateFromAt

► **hydrateFromAt**(address: *`string`*): `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[hydrateFromAt](../interfaces/IContractWrapperBase.md#hydrateFromAt)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromAt](ContractWrapperBase.md#hydrateFromAt)*

*Defined in [contractWrapperBase.ts:96](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L96)*



Initialize from a given address on the current network.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| address | `string`   |  of the deployed contract |





**Returns:** `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>
this or undefined if not found






___

<a id="hydrateFromDeployed"></a>

###  hydrateFromDeployed

► **hydrateFromDeployed**(): `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[hydrateFromDeployed](../interfaces/IContractWrapperBase.md#hydrateFromDeployed)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromDeployed](ContractWrapperBase.md#hydrateFromDeployed)*

*Defined in [contractWrapperBase.ts:114](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L114)*



Initialize as it was migrated by Arc.js on the current network.




**Returns:** `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>
this or undefined if not found






___

<a id="hydrateFromNew"></a>

###  hydrateFromNew

► **hydrateFromNew**(...rest: *`Array`.<`any`>*): `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>



*Implementation of [IContractWrapperBase](../interfaces/IContractWrapperBase.md).[hydrateFromNew](../interfaces/IContractWrapperBase.md#hydrateFromNew)*

*Inherited from [ContractWrapperBase](ContractWrapperBase.md).[hydrateFromNew](ContractWrapperBase.md#hydrateFromNew)*

*Defined in [contractWrapperBase.ts:77](https://github.com/daostack/arc.js/blob/9063ecdf/lib/contractWrapperBase.ts#L77)*



Initialize from a newly-migrated instance. This will migrate a new instance of the contract to the net.


**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| rest | `Array`.<`any`>   |  - |





**Returns:** `Promise`.<[IContractWrapperBase](../interfaces/IContractWrapperBase.md)>
this






___

<a id="proposeController"></a>

###  proposeController

► **proposeController**(options?: *[ProposeControllerParams](../interfaces/ProposeControllerParams.md)*): `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>



*Defined in [wrappers/upgradeScheme.ts:40](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L40)*



Submit a proposal to change the DAO's controller.


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ProposeControllerParams](../interfaces/ProposeControllerParams.md)  |  {} as ProposeControllerParams &amp; TxGeneratingFunctionOptions |   - |





**Returns:** `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>





___

<a id="proposeUpgradingScheme"></a>

###  proposeUpgradingScheme

► **proposeUpgradingScheme**(options?: *[ProposeUpgradingSchemeParams](../interfaces/ProposeUpgradingSchemeParams.md)*): `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>



*Defined in [wrappers/upgradeScheme.ts:68](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L68)*



Submit a proposal to change or modify the DAO's upgrading scheme.


**Parameters:**

| Param | Type | Default value | Description |
| ------ | ------ | ------ | ------ |
| options | [ProposeUpgradingSchemeParams](../interfaces/ProposeUpgradingSchemeParams.md)  |  {} as ProposeUpgradingSchemeParams &amp; TxGeneratingFunctionOptions |   - |





**Returns:** `Promise`.<[ArcTransactionProposalResult](ArcTransactionProposalResult.md)>





___

<a id="setParameters"></a>

###  setParameters

► **setParameters**(params: *[StandardSchemeParams](../interfaces/StandardSchemeParams.md)`TxGeneratingFunctionOptions`*): `Promise`.<[ArcTransactionDataResult](ArcTransactionDataResult.md)[Hash](../#Hash)>



*Overrides [ContractWrapperBase](ContractWrapperBase.md).[setParameters](ContractWrapperBase.md#setParameters)*

*Defined in [wrappers/upgradeScheme.ts:104](https://github.com/daostack/arc.js/blob/9063ecdf/lib/wrappers/upgradeScheme.ts#L104)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| params | [StandardSchemeParams](../interfaces/StandardSchemeParams.md)`TxGeneratingFunctionOptions`   |  - |





**Returns:** `Promise`.<[ArcTransactionDataResult](ArcTransactionDataResult.md)[Hash](../#Hash)>





___


